--               Eushow v1.0  16 colour version                     -------

--This is a comment line...

------------------------------------------------------------------------------
--                  interpreter Directives                             -------
------------------------------------------------------------------------------
--               "with" = ON      "without" = OFF                      -------
------------------------------------------------------------------------------

--with profile       --initially OFF
--with profile_time  --initially OFF
--with trace         --initially OFF

--with warning       --initially ON
--with type_check    --initially ON

------------------------------------------------------------------------------
--           "Include" files with extension "e" or "ew"                -------
------------------------------------------------------------------------------

include get.e       
include image.e
include plist16.e  -- the "playlist" with 16-colour files 

------------------------------------------------------------------------------
--                        Constants                                    -------
------------------------------------------------------------------------------

--constant name_of_never_changing_"variables"_in_the_program = setvalue

constant ERR = 2    

------------------------------------------------------------------------------
--                          Types                                      -------
------------------------------------------------------------------------------

--type name_of_function_which_sets_allowed_values_of_a_variable
--return whether_value_is_allowed_or_not_as_true_or_false
--end type

--No types defined in this program...

------------------------------------------------------------------------------
--            Global atom and sequence variables                       -------
------------------------------------------------------------------------------

--atom name_of_single_value
--sequence name_of_collection_of_values
--integer name_of_integer
--object name_of_variable_which_can_be_any_value


sequence image,Palette,vc,tempword,filename  
object bitmap
integer mode,nr_of_bitmaps,counter,duration


------------------------------------------------------------------------------
--                        Procedures                                   -------
------------------------------------------------------------------------------

--procedure procedure_title (type_of_parameter name_of_parameter,...)
--...
--end procedure

------------------Procedures needed by mainloop--------------------------------

procedure checkbmp()

filename = imagelist[counter][1]  -- extract the current filename
                                  -- from the "playlist"
bitmap = read_bitmap(filename)    -- prepare to display *.bmp-file
tempword = imagelist[counter][1]
Palette = bitmap[1]
image = bitmap[2]

if atom(bitmap) then              -- for when things go wrong...
    
    if bitmap = BMP_OPEN_FAILED then
	puts(ERR, tempword & ": " & "couldn't open\n")
    elsif bitmap = BMP_UNEXPECTED_EOF then
	puts(ERR, tempword & ": " & "unexpected end of file\n")
    else
	puts(ERR, tempword & ": " & "unsupported format\n")
    end if
    abort(1)
end if

end procedure

---------------------------------------------------------------------------------

procedure showbmp()         

clear_screen()

all_palette(Palette/4)      -- set the whole palette

display_image({0,0}, image) -- and show the *.bmp

end procedure

---------------------------------------------------------------------------------

procedure wait()

sleep(duration)

end procedure

---------------------------------------------------------------------------------

------------------------------------------------------------------------------
--                         Functions                                   -------
------------------------------------------------------------------------------

--function function_name (type_of_parameter name_of_parameter,...)
--...
--return name_of_var
--end function

--No functions in this program...

------------------The THREE MAIN PROCEDURES-------------------------------------

procedure init()

nr_of_bitmaps = length(imagelist) -- how many *.bmp are in the list?
counter = 1                       -- to keep track of our current *.bmp-file
duration = 1                      -- default value of one second time per *.bmp

--   18  640 x 480, 16 color      -- Some screen resolutions
--   19  320 x 200, 256 color
--  256  640 x 400, 256 color  
--  257  640 x 480, 256 color  
--  258  800 x 600, 16 color
--  259  800 x 600, 256 color
--  260  1024 x 768, 16 color
--  261  1024 x 768, 256 color

-- WARNING:set "mode" to a resolution your monitor can handle!
-- Older monitors can only go as far as 640 x 480 !!
 
mode = 18


if graphics_mode(mode) then
    puts(ERR, "bad graphics mode\n")
    abort(1)
end if

end procedure

--------------------------------------------------------------------------

procedure mainloop()

while 1 do                               -- MAIN LOOP START


      checkbmp()

      showbmp()

      duration = imagelist[counter][2]   -- extract the duration 
                                         -- from the "playlist"
	 wait()                          

      counter = counter + 1

     if counter > nr_of_bitmaps then
        counter = 1
     end if

	if get_key() != -1 then          -- If a key 
	    exit                         -- is pressed 
	end if                           -- we exit the loop

end while                                -- MAIN LOOP END 

end procedure

--------------------------------------------------------------------------

procedure cleanupandexit()


if graphics_mode(-1) then
end if

abort(0)
end procedure

--------------------------------------------------------------------------

------------------------------------------------------------------------------
--                     PROGRAM STARTS HERE                             -------
------------------------------------------------------------------------------

init()
mainloop()
cleanupandexit()


